/*
 * Created on 2020-03-03 ( Time 13:45:01 )
 * Generated by Telosys Tools Generator ( version 3.1.2 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.salaamsolutions.projet.spasuce.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;
import java.util.List;

import javax.persistence.*;

import lombok.*;

/**
 * Persistent class for entity stored in table "offre"
 *
* @author Back-End developper
   *
 */

@Entity
@Table(name="offre" )
@Data // getters setters
@AllArgsConstructor // constructeur avec arguments
@NoArgsConstructor // constructeur sans arguments
public class Offre implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Column(name="code", length=255)
    private String     code         ;

	/*
	 * 
	 */
    @Column(name="code_contrat", length=255)
    private String     codeContrat  ;

	/*
	 * 
	 */
    @Column(name="message_client")
    private String     messageClient ;

	/*
	 * 
	 */
    @Column(name="is_selected_by_client")
    private Boolean    isSelectedByClient ;

	/*
	 * 
	 */
    @Column(name="commentaire")
    private String     commentaire  ;

	/*
	 * 
	 */
    @Column(name="note_offre")
    private Float      noteOffre    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_soumission")
    private Date       dateSoumission ;

	/*
	 * 
	 */
    @Column(name="is_payer")
    private Boolean    isPayer      ;

	/*
	 * Pour savoir si l'offre à été notée par le client 
	 */
    @Column(name="is_noter_by_client")
    private Boolean    isNoterByClient ;

	/*
	 * Pour savoir si le fournisseur à vu sa note pour eviter toutes modifications apres
	 */
    @Column(name="is_visualiser_note_by_fournisseur")
    private Boolean    isVisualiserNoteByFournisseur ;

	/*
	 * Quand le client aura  cliqué sur la notification
	 */
    @Column(name="is_visualiser_notif_by_client")
    private Boolean    isVisualiserNotifByClient ;

	/*
	 * Quand le client aura lu le contenu de la notification	
	 */
    @Column(name="is_visualiser_contenu_by_client")
    private Boolean    isVisualiserContenuByClient ;

	/*
	 * Pour savoir si le fournisseur peut toujours modifier l'offre
	 */
    @Column(name="is_modifiable")
    private Boolean    isModifiable ;

	/*
	 * Pour dire que l'offre a été modifier après soumission dans le système
	 */
    @Column(name="is_update")
    private Boolean    isUpdate     ;

	/*
	 * Pour dire que l'offre a été retirer par le fournisseur concernant cet appel d'offres
	 */
    @Column(name="is_retirer")
    private Boolean    isRetirer    ;

	/*
	 * 
	 */
    @Column(name="prix")
    private Integer    prix         ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	// "appelDoffresId" (column "appel_doffres_id") is not defined by itself because used as FK in a link 
	// "classeNoteId" (column "classe_note_id") is not defined by itself because used as FK in a link 
	// "userFournisseurId" (column "user_fournisseur_id") is not defined by itself because used as FK in a link 
	// "etatId" (column "etat_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="etat_id", referencedColumnName="id")
        private Etat etat;
    @ManyToOne
    @JoinColumn(name="classe_note_id", referencedColumnName="id")
        private ClasseNote classeNote;
    @ManyToOne
    @JoinColumn(name="user_fournisseur_id", referencedColumnName="id")
        private User user;
    @ManyToOne
    @JoinColumn(name="appel_doffres_id", referencedColumnName="id")
        private AppelDoffres appelDoffres;

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
